您的位置:首页 > 其它

HDU 5543 Pick The Sticks(0-1背包)

2017-08-07 19:26 411 查看
传送门:点击打开链接


Pick The Sticks

Time Limit: 15000/10000 MS (Java/Others)    Memory Limit: 65535/65535 K (Java/Others)

Total Submission(s): 2063    Accepted Submission(s): 657


Problem Description

The story happened long long ago. One day, Cao Cao made a special order called "Chicken Rib" to his army. No one got his point and all became very panic. However, Cao Cao himself felt very proud of his interesting idea and enjoyed it.

Xiu Yang, one of the cleverest counselors of Cao Cao, understood the command Rather than keep it to himself, he told the point to the whole army. Cao Cao got very angry at his cleverness and would like to punish Xiu Yang. But how can you punish someone because
he's clever? By looking at the chicken rib, he finally got a new idea to punish Xiu Yang.

He told Xiu Yang that as his reward of encrypting the special order, he could take as many gold sticks as possible from his desk. But he could only use one stick as the container.

Formally, we can treat the container stick as an L length
segment. And the gold sticks as segments too. There were many gold sticks with different length ai and
value vi.
Xiu Yang needed to put these gold segments onto the container segment. No gold segment was allowed to be overlapped. Luckily, Xiu Yang came up with a good idea. On the two sides of the container, he could make part of the gold sticks outside the container
as long as the center of the gravity of each gold stick was still within the container. This could help him get more valuable gold sticks.

As a result, Xiu Yang took too many gold sticks which made Cao Cao much more angry. Cao Cao killed Xiu Yang before he made himself home. So no one knows how many gold sticks Xiu Yang made it in the container.

Can you help solve the mystery by finding out what's the maximum value of the gold sticks Xiu Yang could have taken?

 

Input

The first line of the input gives the number of test cases, T(1≤T≤100). T test
cases follow. Each test case start with two integers, N(1≤N≤1000) and L(1≤L≤2000),
represents the number of gold sticks and the length of the container stick. N lines
follow. Each line consist of two integers, ai(1≤ai≤2000)and vi(1≤vi≤109),
represents the length and the value of the ith gold
stick.

 

Output

For each test case, output one line containing Case #x: y, where x is
the test case number (starting from 1) and y is
the maximum value of the gold sticks Xiu Yang could have taken.

 

Sample Input

4

3 7
4 1
2 1
8 1

3 7
4 2
2 1
8 4

3 5
4 1
2 2
8 9

1 1
10 3

 

Sample Output

Case #1: 2
Case #2: 6
Case #3: 11
Case #4: 3
Hint
In the third case, assume the container is lay on x-axis from 0 to 5. Xiu Yang could put the second gold stick center at 0 and put the third gold stick center at 5,
so none of them will drop and he can get total 2+9=11 value.

In the fourth case, Xiu Yang could just put the only gold stick center on any position of [0,1], and he can get the value of 3.

题意是给你一固定容量的容器长度,两侧只要保证物体的重点在容器上就可以放置,然后给定一系列物品的长度和价值,问最后能放的最大价值是多少。

问题的关键在于物体可以伸出来,以前的背包问题可以用一维解决恰好放置的问题,此时多了一种状态,不妨将dp数组加一维,用dp[i][j]表示总的长度为i时,此时容器的状态,j为0表示未伸出,j为1表示伸出一端,j为2表示伸出两端。枚举物品,枚举物体的价值,由于有的地方需要将长度/2,背包时要用长度做下标,这样为了避免精度问题,将所有有关长度都*2.枚举背包的三种状态,得到递推式:dp[j][k]=max(dp[j][k],dp[j-w[i]][k]+val[i])跟dp[j][k]=max(dp[j][k],dp[j-w[i]/2][k-1]+val[i])。



代码实现:

#include<iostream>
#include<algorithm>
#include<cstring>
#include<cmath>
#define ll long long

using namespace std;
const int maxn=5005;
int dp[maxn][3];
int main()
{
ll dp[maxn][4],val[maxn],w[maxn],n,l,t,i,j,k,flag=1;
cin>>t;
while(t--)
{
memset(dp,0,sizeof(dp));
cin>>n>>l;
l*=2;
ll maxl=0;
for(i=0;i<n;i++)
{
cin>>w[i]>>val[i];
w[i]*=2;
maxl=max(maxl,val[i]);
}
for(i=0;i<n;i++)
{
for(j=l;j>=w[i]/2;j--)
{
for(k=0;k<3;k++)
{
if(j>=w[i])
dp[j][k]=max(dp[j][k],dp[j-w[i]][k]+val[i]);
if(k)
dp[j][k]=max(dp[j][k],dp[j-w[i]/2][k-1]+val[i]);

maxl=max(maxl,dp[j][k]);
}
}
}
cout<<"Case #"<<flag++<<": ";
cout<<maxl<<endl;
}
return 0;
}
内容来自用户分享和网络整理,不保证内容的准确性,如有侵权内容,可联系管理员处理 点击这里给我发消息
标签: